package HT.fx;

import java.util.List;

/**
 * @author joonatan, thmustap
 * @version 7.3.2024
 *
 */
public class Karkelot {
    private final Pelaajat pelaajat = new Pelaajat();
    private final Ottelut ottelut = new Ottelut();
    
    /**
     * Palautaa pelaajien määrän
     * @return pelaajatmäärä
     */
    public int getPelaajia() {
        return pelaajat.getLkm();
    }
    
    /**
     * Poistaa pelaajat aj ottelut tietyllä luvulla
     * @param nro , kuka poistetaan
     * @return montako poiistettiin
     */
    public int poista(@SuppressWarnings("unused") int nro) {
        return 0;
    }
    
    /**
     * lisää pelaajan
     * @param pelaaja pelaaja
     * @throws SailoException virhe
     */
    public void lisaa(Pelaaja pelaaja) throws SailoException {
        pelaajat.lisaa(pelaaja);
    }
    
    /**
     * Listään uusi harrastus kerhoon
     * @param ott lisättävä harrastus 
     */
    public void lisaa(Ottelu ott) {
        ottelut.lisaa(ott);
    }

    
    /**
     * Palauttaa i:n pelaajan 
     * @param i monesko pelaaja 
     * @return viite i:teen jäseneen
     * @throws IndexOutOfBoundsException jos i väärin
     */
    public Pelaaja annaPelaaja(int i) throws IndexOutOfBoundsException {
        return pelaajat.anna(i);
    }
    
    /**
     * @param pelaaja pelaaja kenelt' annetaan
     * @return palauttaa Ottelut
     */
    public List<Ottelu> annaOttelut(Pelaaja pelaaja) {
        return ottelut.annaOttelut(pelaaja.getTunnusNro());
    }
    
    /**
     * Hakee i:nnen ottelun ottelut oliolta
     * @param i monesko ottelu haetaan
     * @return ottelun
     */
    public Ottelu noudaOttelu(int i) {
        return ottelut.haeOttelu(i);
    }
    
    
    /**
     * Lukee  tiedot tiedostosta
     * @param nimi joka luetaan
     * @throws SailoException virhe
     */
    public void lueTiedostosta(String nimi) throws SailoException {
        pelaajat.lueTiedostosta(nimi);
       //ottelut.lueTiedostosta(nimi);
    }
 
    
    /**
     * Tallentaa tiedot tiedostoon
     * @throws SailoException virhe
     */
    public void talleta() throws SailoException {
        pelaajat.talleta();
        
    }
    
    /**
     * Testiohjelma kerhosta
     * @param args ei käytössä
     */
    public static void main(String args[]) {
        Karkelot karkelo = new Karkelot();

        try {
            // kerho.lueTiedostosta("kelmit");

            Pelaaja aku1 = new Pelaaja(), aku2 = new Pelaaja();
            aku1.rekisteroi();
            aku1.vastaaAkuAnkka();
            aku2.rekisteroi();
            aku2.vastaaAkuAnkka();

            karkelo.lisaa(aku1);
            karkelo.lisaa(aku2);

            System.out.println("============= Kerhon testi =================");

            for (int i = 0; i < karkelo.getPelaajia(); i++) {
                Pelaaja pelaaja = karkelo.annaPelaaja(i);
                System.out.println("Pelaaja paikassa: " + i);
                pelaaja.tulosta(System.out);
            }

        } catch (SailoException ex) {
            System.out.println(ex.getMessage());
        }
    }









}
