package HT.fx;

import fi.jyu.mit.fxgui.CheckBoxChooser;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.DatePicker;
import javafx.scene.control.MenuButton;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseEvent;
import javafx.stage.Stage;

/**
 * @author joonatan, tuomas
 * @version 13.3.2024
 *
 */
public class PadelLisaaOtteluGUIController implements ModalControllerInterface<String> {
    
    @FXML private Button OKButton;

    @FXML private ComboBoxChooser<String> menuOsallistuja1;

    @FXML private ComboBoxChooser<String> menuOsallistuja2;

    @FXML private ComboBoxChooser<String> menuOsallistuja3;

    @FXML private ComboBoxChooser<String> menuOsallistuja4;

    @FXML private ComboBoxChooser<String> menuVoittaja1;

    @FXML private ComboBoxChooser<String> menuVoittaja2;

    @FXML private DatePicker otteluPvm;

    @FXML private TextField textLopputulos;

    @FXML void handleOk() {
        kasitteleOk();
        Stage stage = (Stage) OKButton.getScene().getWindow();
        stage.close();
    }

    /**
     * Tällä hetkellä ei poista mitään, vaan toimii käytännössä päivitä nappina
     */
    @FXML void handlePoista() {
        alusta(menuOsallistuja1);
        alusta(menuOsallistuja2);
        alusta(menuOsallistuja3);
        alusta(menuOsallistuja4);
        alusta(menuVoittaja1);
        alusta(menuVoittaja2);
        Dialogs.showMessageDialog("Ei osata vielä");
    }

    //=======================================================
    
    /**
     * Lisää vaihtoehdot parametrina annetulle valintamenulle
     * @param menu mihin menuun lisätään
     */
    private void alusta(ComboBoxChooser<String> menu) {
        menu.clear();
        int i = 0;
        
        int lukumaara = PadelMainGUIController.getKarkelo().getPelaajia();
        while(i< lukumaara) {
            menu.add(PadelMainGUIController.getKarkelo().annaPelaaja(i).getNimi(), null);
            i++;
        }
    }
    
    /**
     * Käsittelee ok napin. Hakee jokaisen valitun indeksin ja tekee 
     * näistä ottelun main controllerin karkeloon
     */
    public void kasitteleOk() {
        //String pvm = datesyntaika.getValue().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        int PelaajaNro1 = menuOsallistuja1.getSelectedIndex();
        int PelaajaNro2 = menuOsallistuja2.getSelectedIndex();
        int PelaajaNro3 = menuOsallistuja3.getSelectedIndex();
        int PelaajaNro4 = menuOsallistuja4.getSelectedIndex();
        int VoittajaNro1 = menuVoittaja1.getSelectedIndex();
        int VoittajaNro2 = menuVoittaja2.getSelectedIndex();
        String lopputulos = textLopputulos.getText();

        
        Ottelu uusi = new Ottelu(otteluPvm.getValue(), PelaajaNro1, PelaajaNro2, PelaajaNro3, PelaajaNro4, VoittajaNro1, VoittajaNro2, lopputulos);
        //uusi.vastaaAkuAnkka();
        PadelMainGUIController.LisaaOttelu(uusi); // lisää pelaajan karkeloon
    
    }
    
    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }
}
